/*
	
	BLinearPlot.h
    Defines the foundation of several classes of plots,
    such as BLinearPlot
    Copyright (c) 1996 by Erik Rubin
    All Rights Reserves
    Created December 23, 1996

*/

#ifndef BLINEARPLOT_H
#define BLINEARPLOT_H

#ifndef _VIEW_H
#include <View.h>
#endif

#define MAX_X_LABEL                        100
#define MAX_Y_LABEL                        20
#define MAXSETS                            5
#define MAXPOINTS                          500




class BLinearPlot : private BView {

public:
                    BLinearPlot(BRect frame, char *name, char * X_Label, char * Y_Label); 
  bool              ReceiveDataSet(float Data[MAXPOINTS], int SetNumber, int TotalPoints,
                                   bool ImmediateRefresh);
  bool              SetPlotColor(int SetNumber, rgb_color PlotColor);
  bool              SetBackColor(rgb_color BackColor);
  bool              ConnectDots(int SetNumber, bool Connect);
  bool              XTicks(bool Enabled, int Interval);
  bool              YTicks(bool Enabled, int Interval);
  bool              XAxis_TickNumbers(bool Enabled, int Interval);
  bool              YAxis_TickNumbers(bool Enabled, int Interval);
  bool              ShouldDrawFinalXLabel(bool Enabled);
  bool              ShouldDrawFinalYLabel(bool Enabled);

private:
  

  BRect  CurrentBounds;                          
  char   Class_XLabel[MAX_X_LABEL];
  char   Class_YLabel[MAX_Y_LABEL];
  bool   DataLoaded;                       
  bool   UsingSet[MAXSETS];                
  int    NumPoints;                          
  bool   XTicksEnabled;                           
  bool   YTicksEnabled;                           // flags whether Y Ticks are on or off
  bool   XTickNumbersEnabled;
  bool   YTickNumbersEnabled;
  int    XTick_Interval;                          
  int    XTickNum_Interval;
  float  YTick_Interval;                          // spacing interval for the Y ticks
  float  YTickNum_Interval;
  bool   ShouldDrawFinalX;                        // flags whether to draw the final y label at the top of the y axis
  bool   ShouldDrawFinalY;                        // flags whether to draw the final y label at the top of the y axis

  float  MinimumY;                            
  float  MaximumY;                           
  float  RightMostGraphPixel;
  float  LeftMostGraphPixel;
  float  TopMostGraphPixel;
  float  BottomMostGraphPixel;
  float  PointData0[MAXPOINTS];             
  float  PointData1[MAXPOINTS];               
  float  PointData2[MAXPOINTS];             
  float  PointData3[MAXPOINTS];               
  float  PointData4[MAXPOINTS];               
  bool   ShouldConnect[MAXSETS];               

  rgb_color AxisAndLabelsColor;                  
  rgb_color Dataset_0_Color;                   
  rgb_color Dataset_1_Color;               
  rgb_color Dataset_2_Color;                  
  rgb_color Dataset_3_Color;                  
  rgb_color Dataset_4_Color;                    
  rgb_color BackgroundColor;                      
};

#endif
